UNIT IDEDEMO;

INTERFACE

USES // SIMFORM  {TYPE TSIMWINDOW},
     // PREVIEW  {VAR  PREVIEWFORM},
     IDEFACT  {TYPE TLINKAGE},
     IDETREE  {TYPE TELEMENT},
     IDEDESC  {TYPE TBASICDESC},
     IDERUN   {FUNC FINDCONTEXT},
     SIMCLS   {TYPE TSIMWINDOW},
     SIMCTL   {TYPE TSIMWINDOW_ELEMENT};

PROCEDURE DEMO (TOP: TELEMENT);
{ CREATE PREVIEW OF A WINDOW }

IMPLEMENTATION

(********************************** DEMO **********************************)

PROCEDURE CREATEVIEWBRANCH (ELEM: TELEMENT);
{ CREATE PRODUCTS  }
VAR  SUB: TELEMENT;
     REL: TLINKAGE;
     LOC: TELEMENT;
BEGIN
     { CREATE PRODUCT }
     ASSERT (ELEM <> NIL);
     ELEM.PRODUCT := ELEM.CREATEPRODUCT;
     ASSERT (ELEM.PRODUCT <> NIL);

     { SUBITEMS }
     SUB := ELEM.FIRSTELEM;
     WHILE SUB <> NIL DO BEGIN

        { CREATE SUBITEM }
        CREATEVIEWBRANCH (SUB);

        { LINK TREE }
        IF (ELEM.PRODUCT <> NIL) AND (SUB.PRODUCT <> NIL) THEN BEGIN
           FINDCONTEXT (ELEM, SUB, LOC, REL);
           IF REL <> NIL THEN
              REL.INSERTLAST (LOC.PRODUCT, SUB.PRODUCT);
        END;

        SUB := SUB.NEXTELEM;
     END;
END;

{--------------------------------------------------------------------------}

PROCEDURE SETUPVIEWBRANCH (ELEM: TELEMENT);
{ STORE PARAMETER VALUES }
VAR  SUB: TELEMENT;
     PARAM: TPARAM;
BEGIN
     IF ELEM.PRODUCT <> NIL THEN BEGIN
        PARAM := ELEM.FIRSTPARAM;
        WHILE PARAM <> NIL DO BEGIN
           PARAM.STORE (ELEM.PRODUCT);
           PARAM := PARAM.NEXTPARAM;
        END;
     END;

     { SETUP SUBITEMS }
     SUB := ELEM.FIRSTELEM;
     WHILE SUB <> NIL DO BEGIN
        SETUPVIEWBRANCH (SUB);
        SUB := SUB.NEXTELEM;
     END;
END;

{--------------------------------------------------------------------------}

PROCEDURE DEMO (TOP: TELEMENT);
VAR  WIN: TSIMWINDOW;
BEGIN
     WHILE (TOP <> NIL) AND NOT (TOP IS TSIMWINDOW_ELEMENT) DO
        TOP := TOP.UPPERELEM;

     IF TOP <> NIL THEN BEGIN

        CREATEVIEWBRANCH (TOP);
        SETUPVIEWBRANCH (TOP);

        IF TOP.PRODUCT IS TSIMWINDOW THEN BEGIN
           WIN := TOP.PRODUCT AS TSIMWINDOW;
           WIN.SHOW;
        END;
     END;
END;

END.
