
/* lookio.h */

/* Language Input / Output */

#ifndef __PROG_LOOKIO_H__
#define __PROG_LOOKIO_H__

#include "envio.h"

OPEN_NAMESPACE

/* ---------------------------------------------------------------------- */

typedef int TInputSymbol;

typedef TInputItem * TInputMark;

/* ---------------------------------------------------------------------- */

#if 0
class TInputItem
{
   public:
      TInputSymbol symbol;

      TTokenKind kind;
      string token_txt;

   public:
      int file_num;
      int line_num;
      int col_num;

   public:
      TInputItem * next;

      TInputItem * prev_comment;
      TInputItem * next_token; // next valid token ( not comment or space )

   public:
      bool is_comment ()
      {
         return kind == CommentToken ||
                kind == SpaceToken ||
                kind == EolToken ||
                kind == UnusedDirectiveToken;
      }

      void clear ();

      TInputItem ();
      friend class TInputQueue;
};
#endif

/* ---------------------------------------------------------------------- */

#if 0
class TInputQueue
{
   public:
      TInputItem * first;
      TInputItem * last;

      TInputItem * first_free;
      TInputItem * last_free;

   public:
      void insertLast (TInputItem * item);
      TInputItem * removeFirst ();

      void insertLastFree (TInputItem * item);
      TInputItem * removeFirstFree ();

      void removeAll ();

   public:
      TInputQueue ();
      virtual ~ TInputQueue ();
      friend class TInputItem;
};
#endif

/* ---------------------------------------------------------------------- */

class TLexerInput : public TEnvInput
{
   public:
      int mark_level;
      TInputSymbol actual;

      TInputItem * present;
      TInputQueue queue;

      bool comments;

   public:
      virtual string conv (TInputSymbol sym) { return "???"; }
      virtual void translate () { }

   public:
      inline bool symbol (TInputSymbol s) // test current symbol
      {
         return actual == s;
      }

      inline bool test (const unsigned char table []) // test current symbol with table
      {
         int pos = actual / 8;
         int bit = actual % 8;
         return table [pos] & (1 << bit);
      }

   public:
      TInputSymbol LA (int i);
      void match (TInputSymbol s);
      void next ();

      void pick (); // recall from queue
      void remember (); // store data to queue
      void read ();

      // TInputItem * getLocation ();

      TInputItem * mark ();
      void rewind (TInputItem * pos);
      void skip_rewind ();

      void stop (string msg);
      void stop ();

      void save_trace () { EliminateMessages (); }
      void restore_trace () { RestoreMessages (); }

   public:
      virtual void Init ();

      TLexerInput ();
      virtual ~TLexerInput ();
};

/* ---------------------------------------------------------------------- */

CLOSE_NAMESPACE

#endif /* __PROG_LOOKIO_H__ */
